function SMILE_01

%Create the main figure for the GUI
h =  findobj('type','figure');
if isempty(h)
    v = 0;
else
    v = zeros(length(h),1);
    for n = 1:length(h)
        v(n) = h(n).Number;
        
    end
end
 FigH = figure(max(v)+1);
 set(FigH, 'NumberTitle', 'off', ...
    'Name', 'SMILE');
set(gcf,'position',[84, 191, 1272, 607])

%Create the tabs for the different panels
tabgroup = uitabgroup(gcf,'position',[0.01,0.01,0.98,0.98],'Tag','TabG');
AnalysisL = uitab(tabgroup,'Title','Lines','Tag','LinesTab');
ParametersL = uitab(tabgroup,'Title','Parameters','Tag','ParametersTab');

Ax1 = axes('parent',AnalysisL,'position',[0.05,0.45,0.5,0.5],'Tag','Ax1');
Ax2 = axes('parent',AnalysisL,'position',[0.05,0.07,0.4,0.3],'Tag','Ax2');
set(AnalysisL,'UserData',[Ax1, Ax2]);

pb_Stop = uicontrol('parent',AnalysisL);
pb_Stop.Style = 'PushButton';
pb_Stop.Units = 'Normalized';
pb_Stop.Position = [0.8, 0.11, 0.1, 0.05];
pb_Stop.String = 'Stop';
pb_Stop.Callback = @StopProcessing;
pb_Stop.Tag = 'pb_Stop';
pb_Stop.Visible = false(1);

pb_Errors = uicontrol('parent',AnalysisL);
pb_Errors.Style = 'PushButton';
pb_Errors.Units = 'Normalized';
pb_Errors.Position = [0.6, 0.8, 0.1, 0.05];
pb_Errors.String = 'Show Errors';
pb_Errors.Callback = @toggleErrors;
pb_Errors.Tag = 'pb_Errors';
pb_Errors.UserData = false(1);

pb_folder = uicontrol('parent',AnalysisL);
pb_folder.Style = 'PushButton';
pb_folder.Units = 'Normalized';
pb_folder.Position = [0.6, 0.9, 0.1, 0.05];
pb_folder.String = 'Images Folder';
pb_folder.TooltipString = pwd;
pb_folder.Callback = @selectImageFolder;
pb_folder.Tag = 'pb_folder';

pb_selectAll = uicontrol('parent',AnalysisL);
pb_selectAll.Style = 'PushButton';
pb_selectAll.Units = 'Normalized';
pb_selectAll.Position = [0.6, 0.75, 0.08, 0.05];
pb_selectAll.String = 'Select all';
pb_selectAll.Callback = @SelectAll;
pb_selectAll.Tag = 'pb_selectAll';

pb_unselectAll = uicontrol('parent',AnalysisL);
pb_unselectAll.Style = 'PushButton';
pb_unselectAll.Units = 'Normalized';
pb_unselectAll.Position = [0.6, 0.7, 0.08, 0.05];
pb_unselectAll.String = 'Unselect all';
pb_unselectAll.Callback = @UnselectAll;
pb_unselectAll.Tag = 'pb_unselectAll';

pb_measure = uicontrol('parent',AnalysisL);
pb_measure.Style = 'PushButton';
pb_measure.Units = 'Normalized';
pb_measure.Position = [0.6, 0.85, 0.1, 0.05];
pb_measure.String = 'Process images';
pb_measure.TooltipString = pwd;
pb_measure.Callback = @ImProc01;
pb_measure.Tag = 'pb_measure';

% pb_Processing = uicontrol('parent',AnalysisL);
% pb_Processing.Style = 'PushButton';
% pb_Processing.Units = 'Normalized';
% pb_Processing.Position = [0.65, 0.05, 0.08, 0.05];
% pb_Processing.String = 'Stop processing';
% pb_Processing.Tag = 'Pb_stop';
% pb_Processing.Callback = @stopflag;

% pb_measure = uicontrol('parent',AnalysisL);
% pb_measure.Style = 'PushButton';
% pb_measure.Units = 'Normalized';
% pb_measure.Position = [0.6, 0.85, 0.1, 0.05];
% pb_measure.String = 'Process images';
% pb_measure.TooltipString = pwd;
% pb_measure.Callback = @ImProc01;
% pb_measure.Tag = 'pb_measure';



pb_export = uicontrol('parent',AnalysisL);
pb_export.Style = 'PushButton';
pb_export.Units = 'Normalized';
pb_export.Position = [0.8, 0.9, 0.1, 0.05];
pb_export.String = 'Export data';
pb_export.Callback = @exportData;
pb_export.Tag = 'pb_export';

bg_SelectPlot = uibuttongroup('parent',AnalysisL);
bg_SelectPlot.Units = 'Normalized';
bg_SelectPlot.Position = [0.47, 0.15, 0.07, 0.2];
bg_SelectPlot.Visible = 'off';
bg_SelectPlot.SelectionChangedFcn = @selectPlot;
bg_SelectPlot.Tag = 'bg_SelectPlot';

rb_PSDPlot = uicontrol();
rb_PSDPlot.Parent = bg_SelectPlot;
rb_PSDPlot.Style = 'RadioButton';
rb_PSDPlot.Units = 'Normalized';
rb_PSDPlot.Position = [0.01, 0.0, 1, 0.3];
rb_PSDPlot.String = 'PSD';
rb_PSDPlot.HandleVisibility = 'off';

rb_HHPlot = uicontrol();
rb_HHPlot.Parent = bg_SelectPlot;
rb_HHPlot.Style = 'RadioButton';
rb_HHPlot.Units = 'Normalized';
rb_HHPlot.Position = [0.01, 0.35, 1, 0.3];
rb_HHPlot.String = 'HHCF';
rb_HHPlot.HandleVisibility = 'off';

rb_LCDUPlot = uicontrol();
rb_LCDUPlot.Parent = bg_SelectPlot;
rb_LCDUPlot.Style = 'RadioButton';
rb_LCDUPlot.Units = 'Normalized';
rb_LCDUPlot.Position = [0.01, 0.7, 1, 0.3];
rb_LCDUPlot.String = 'LCDU';
rb_LCDUPlot.HandleVisibility = 'off';

bg_SelectPlot.Visible = 'on';



tab_images = uitable('parent',AnalysisL);
tab_images.Units = 'Normalized';
tab_images.Position = [0.6, 0.2, 0.35, 0.5];
tab_images.ColumnName = {'','file','meanCD','stdCD','Nlines','meanLWR3s','meanLWR_PSD','meanLWR_PSD_Unbiased','meanLWR_PSD_Fit_Unbiased'};
tab_images.Tag = 'tab_images';
tab_images.CellSelectionCallback = @selectImage;
tab_images.ColumnEditable = [true, false, false, false, false, false, false, false, false];

lb_Processing = uicontrol('parent',AnalysisL);
lb_Processing.Style = 'text';
lb_Processing.Units = 'Normalized';
lb_Processing.Position = [0.6, 0.1, 0.2, 0.05];
lb_Processing.String = 'Idle';
lb_Processing.Tag = 'lb_status';


cb_dispAverage = uicontrol('parent',AnalysisL);
cb_dispAverage.Style = 'Checkbox';
cb_dispAverage.Units = 'Normalized';
cb_dispAverage.Position = [0.47, 0.07, 0.14, 0.05];
cb_dispAverage.Value = false;
cb_dispAverage.String = 'Multiple images average';
cb_dispAverage.Tag = 'dispAverage';
cb_dispAverage.Callback = @displayData01;
cb_dispAverage.Visible = false;

%%%
Ax3 = axes('parent',ParametersL,'position',[0.05,0.45,0.5,0.5],'Tag','Ax3');
set(ParametersL,'UserData',Ax3);

pb_ROI = uicontrol('parent',ParametersL);
pb_ROI.Style = 'PushButton';
pb_ROI.Units = 'Normalized';
pb_ROI.Position = [0.7, 0.85, 0.1, 0.05];
pb_ROI.String = 'Set ROI';
pb_ROI.TooltipString = pwd;
pb_ROI.Callback = @setROI;
pb_ROI.Tag = 'pb_ROI';

ed_spikePeak = uicontrol('parent',ParametersL);
ed_spikePeak.Style = 'Edit';
ed_spikePeak.Units = 'Normalized';
ed_spikePeak.Position = [0.65, 0.73, 0.05, 0.05];
ed_spikePeak.String = '4';
ed_spikePeak.Tag = 'ed_spikePeak';
lb_spikePeak = uicontrol('parent',ParametersL);
lb_spikePeak.Style = 'text';
lb_spikePeak.Units = 'Normalized';
lb_spikePeak.Position = [0.6, 0.72, 0.05, 0.05];
lb_spikePeak.String = 'Max. spike.';

ed_CD_fraction = uicontrol('parent',ParametersL);
ed_CD_fraction.Style = 'Edit';
ed_CD_fraction.Units = 'Normalized';
ed_CD_fraction.Position = [0.65, 0.68, 0.05, 0.05];
ed_CD_fraction.String = '0.25';
ed_CD_fraction.Tag = 'CD_fraction';
lb_CD_fraction = uicontrol('parent',ParametersL);
lb_CD_fraction.Style = 'text';
lb_CD_fraction.Units = 'Normalized';
lb_CD_fraction.Position = [0.6, 0.67, 0.05, 0.05];
lb_CD_fraction.String = 'CD Fraction';

cb_rotation = uicontrol('parent',ParametersL);
cb_rotation.Style = 'Checkbox';
cb_rotation.Units = 'Normalized';
cb_rotation.Position = [0.60, 0.62, 0.08, 0.05];
cb_rotation.Value = true;
cb_rotation.String = 'Auto alignment';
cb_rotation.Tag = 'auto_rotation';

cb_distortion = uicontrol('parent',ParametersL);
cb_distortion.Style = 'Checkbox';
cb_distortion.Units = 'Normalized';
cb_distortion.Position = [0.60, 0.58, 0.1, 0.05];
cb_distortion.Value = true;
cb_distortion.String = 'Remove distortion';
cb_distortion.Tag = 'auto_distortion';

ed_peakProm = uicontrol('parent',ParametersL);
ed_peakProm.Style = 'Edit';
ed_peakProm.Units = 'Normalized';
ed_peakProm.Position = [0.82, 0.73, 0.05, 0.05];
ed_peakProm.String = '0.36';
ed_peakProm.Tag = 'ed_peakProm';
lb_peakProm = uicontrol('parent',ParametersL);
lb_peakProm.Style = 'text';
lb_peakProm.Units = 'Normalized';
lb_peakProm.Position = [0.72, 0.72, 0.1, 0.05];
lb_peakProm.String = 'Min peak prominence';

ed_peakDist = uicontrol('parent',ParametersL);
ed_peakDist.Style = 'Edit';
ed_peakDist.Units = 'Normalized';
ed_peakDist.Position = [0.82, 0.78, 0.05, 0.05];
ed_peakDist.String = '10';
ed_peakDist.Tag = 'ed_peakDist';
lb_peakDist = uicontrol('parent',ParametersL);
lb_peakDist.Style = 'text';
lb_peakDist.Units = 'Normalized';
lb_peakDist.Position = [0.72, 0.77, 0.1, 0.05];
lb_peakDist.String = 'Min peak distance';

ed_MFE = uicontrol('parent',ParametersL);
ed_MFE.Style = 'Edit';
ed_MFE.Units = 'Normalized';
ed_MFE.Position = [0.82, 0.68, 0.05, 0.05];
ed_MFE.String = '10000';
ed_MFE.Tag = 'ed_MFE';
lb_MFE = uicontrol('parent',ParametersL);
lb_MFE.Style = 'text';
lb_MFE.Units = 'Normalized';
lb_MFE.Position = [0.72, 0.67, 0.1, 0.05];
lb_MFE.String = 'Max function eval.';

ed_MIT = uicontrol('parent',ParametersL);
ed_MIT.Style = 'Edit';
ed_MIT.Units = 'Normalized';
ed_MIT.Position = [0.82, 0.63, 0.05, 0.05];
ed_MIT.String = '10000';
ed_MIT.Tag = 'ed_MIT';
lb_MIT = uicontrol('parent',ParametersL);
lb_MIT.Style = 'text';
lb_MIT.Units = 'Normalized';
lb_MIT.Position = [0.72, 0.62, 0.1, 0.05];
lb_MIT.String = 'Max iterations';

ed_CF = uicontrol('parent',ParametersL);
ed_CF.Style = 'Edit';
ed_CF.Units = 'Normalized';
ed_CF.Position = [0.82, 0.58, 0.05, 0.05];
ed_CF.String = '2e-2';
ed_CF.Tag = 'ed_CF';
lb_CF = uicontrol('parent',ParametersL);
lb_CF.Style = 'text';
lb_CF.Units = 'Normalized';
lb_CF.Position = [0.72, 0.57, 0.1, 0.05];
lb_CF.String = 'Correlation frequency';

ed_alpha = uicontrol('parent',ParametersL);
ed_alpha.Style = 'Edit';
ed_alpha.Units = 'Normalized';
ed_alpha.Position = [0.82, 0.53, 0.05, 0.05];
ed_alpha.String = '2';
ed_alpha.Tag = 'ed_alpha';
lb_alpha = uicontrol('parent',ParametersL);
lb_alpha.Style = 'text';
lb_alpha.Units = 'Normalized';
lb_alpha.Position = [0.72, 0.52, 0.1, 0.05];
lb_alpha.String = 'Alpha';

ed_Threshold = uicontrol('parent',ParametersL);
ed_Threshold.Style = 'Edit';
ed_Threshold.Units = 'Normalized';
ed_Threshold.Position = [0.65, 0.8, 0.05, 0.05];
ed_Threshold.String = '0.5';
ed_Threshold.Tag = 'ed_Threshold';
lb_Threshold = uicontrol('parent',ParametersL);
lb_Threshold.Style = 'text';
lb_Threshold.Units = 'Normalized';
lb_Threshold.Position = [0.6, 0.79, 0.05, 0.05];
lb_Threshold.String = 'Threshold';

dd_PSDmodel = uicontrol('parent',ParametersL);
dd_PSDmodel.Style = 'popupmenu';
dd_PSDmodel.String = {'Gaussian','FloatingAlpha','NoWhiteNoise','Palasantzas1','Palasantzas2','Integral'};
dd_PSDmodel.Value = 5;
dd_PSDmodel.Units = 'Normalized';
dd_PSDmodel.Position = [0.82,0.4,0.1,0.05];
dd_PSDmodel.Tag = 'PSDmodel';
lb_PSDmodel = uicontrol('parent',ParametersL);
lb_PSDmodel.Style = 'Text';
lb_PSDmodel.String = 'PSD Model';
lb_PSDmodel.Units = 'Normalized';
lb_PSDmodel.Position = [0.77,0.395,0.05,0.05];
lb_PSDmodel.Tag = 'lbPSDmodel';

dd_SEMmodel = uicontrol('parent',ParametersL);
dd_SEMmodel.Style = 'popupmenu';
dd_SEMmodel.String = {'Hitachi','Zeiss','Manual'};
dd_SEMmodel.Value = 3;
dd_SEMmodel.Units = 'Normalized';
dd_SEMmodel.Position = [0.82,0.345,0.1,0.05];
dd_SEMmodel.Tag = 'SEMmodel';
lb_SEMmodel = uicontrol('parent',ParametersL);
lb_SEMmodel.Style = 'Text';
lb_SEMmodel.String = 'SEM Model';
lb_SEMmodel.Units = 'Normalized';
lb_SEMmodel.Position = [0.77,0.34,0.05,0.05];
lb_SEMmodel.Tag = 'lbSEMmodel';





% ed_CD_fraction = uicontrol('parent',ParametersL);
% ed_CD_fraction.Style = 'Edit';
% ed_CD_fraction.Units = 'Normalized';
% ed_CD_fraction.Position = [0.65, 0.58, 0.05, 0.05];
% ed_CD_fraction.String = '0.5';
% ed_CD_fraction.Tag = 'CD_fraction';
% lb_CD_fraction = uicontrol('parent',ParametersL);
% lb_CD_fraction.Style = 'text';
% lb_CD_fraction.Units = 'Normalized';
% lb_CD_fraction.Position = [0.6, 0.57, 0.05, 0.05];
% lb_CD_fraction.String = 'CD Fraction';

ed_PS = uicontrol('parent',ParametersL);
ed_PS.Style = 'Edit';
ed_PS.Units = 'Normalized';
ed_PS.Position = [0.65, 0.51, 0.05, 0.05];
ed_PS.String = '0.8';
ed_PS.Tag = 'parmPS';
lb_PS = uicontrol('parent',ParametersL);
lb_PS.Style = 'text';
lb_PS.Units = 'Normalized';
lb_PS.Position = [0.6, 0.50, 0.05, 0.05];
lb_PS.String = 'Pixel size';

ed_FN = uicontrol('parent',ParametersL);
ed_FN.Style = 'Edit';
ed_FN.Units = 'Normalized';
ed_FN.Position = [0.7, 0.46, 0.05, 0.05];
ed_FN.String = '5';
ed_FN.Tag = 'parmFN';
lb_FN = uicontrol('parent',ParametersL);
lb_FN.Style = 'text';
lb_FN.Units = 'Normalized';
lb_FN.Position = [0.6, 0.45, 0.1, 0.05];
lb_FN.String = 'Low frequency average';

ed_LN = uicontrol('parent',ParametersL);
ed_LN.Style = 'Edit';
ed_LN.Units = 'Normalized';
ed_LN.Position = [0.7, 0.41, 0.05, 0.05];
ed_LN.String = '50';
ed_LN.Tag = 'parmLN';
lb_LN = uicontrol('parent',ParametersL);
lb_LN.Style = 'text';
lb_LN.Units = 'Normalized';
lb_LN.Position = [0.6, 0.40, 0.1, 0.05];
lb_LN.String = 'High frequency average';

ed_ExN = uicontrol('parent',ParametersL);
ed_ExN.Style = 'Edit';
ed_ExN.Units = 'Normalized';
ed_ExN.Position = [0.7, 0.36, 0.05, 0.05];
ed_ExN.String = '1';
ed_ExN.Tag = 'parmExN';
lb_ExN = uicontrol('parent',ParametersL);
lb_ExN.Style = 'text';
lb_ExN.Units = 'Normalized';
lb_ExN.Position = [0.6, 0.35, 0.1, 0.05];
lb_ExN.String = 'Low frequency exclusion';

ed_ExNe = uicontrol('parent',ParametersL);
ed_ExNe.Style = 'Edit';
ed_ExNe.Units = 'Normalized';
ed_ExNe.Position = [0.7, 0.31, 0.05, 0.05];
ed_ExNe.String = '1';
ed_ExNe.Tag = 'parmExNe';
lb_ExNe = uicontrol('parent',ParametersL);
lb_ExNe.Style = 'text';
lb_ExNe.Units = 'Normalized';
lb_ExNe.Position = [0.6, 0.30, 0.1, 0.05];
lb_ExNe.String = 'High frequency exclusion';

pu_flatI = uicontrol('parent',ParametersL);
pu_flatI.Style = 'PopUpMenu';
pu_flatI.Units = 'Normalized';
pu_flatI.Position = [0.15, 0.30, 0.1, 0.05];
pu_flatI.String = [{'None'},{'Linear'},{'Quadratic'},{'Cubic'}];
pu_flatI.Value = 3;
pu_flatI.Tag = 'parmRemGrad';
lb_flatI = uicontrol('parent',ParametersL);
lb_flatI.Style = 'text';
lb_flatI.Units = 'Normalized';
lb_flatI.Position = [0.05, 0.30, 0.1, 0.05];
lb_flatI.String = 'Remove gradient';

pu_edgefit = uicontrol('parent',ParametersL);
pu_edgefit.Style = 'PopUpMenu';
pu_edgefit.Units = 'Normalized';
pu_edgefit.Position = [0.15, 0.24, 0.1, 0.05];
pu_edgefit.String = [{'Linear'},{'4deg'},{'Threshold'}];
pu_edgefit.Value = 1;
pu_edgefit.Tag = 'edgefitF';
lb_edgefit = uicontrol('parent',ParametersL);
lb_edgefit.Style = 'text';
lb_edgefit.Units = 'Normalized';
lb_edgefit.Position = [0.05, 0.24, 0.1, 0.05];
lb_edgefit.String = 'Edge fit function';

lb_manrotate = uicontrol('parent',ParametersL);
lb_manrotate.Style = 'text';
lb_manrotate.Units = 'Normalized';
lb_manrotate.Position = [0.05, 0.15, 0.2, 0.05];
lb_manrotate.String = 'Image rotation adjustment';

sl_manrotate = uicontrol('parent',ParametersL);
sl_manrotate.Style = 'Slider';
sl_manrotate.Units = 'Normalized';
sl_manrotate.Position = [0.05, 0.1, 0.2, 0.05];
sl_manrotate.Value = 0.5;
sl_manrotate.Tag = 'slider_manual_rotation';
sl_manrotate.Callback = @Rotate_image;

ed_bridgTh = uicontrol('parent',ParametersL);
ed_bridgTh.Style = 'Edit';
ed_bridgTh.Units = 'Normalized';
ed_bridgTh.Position = [0.40, 0.30, 0.06, 0.05];
ed_bridgTh.String = '5';
ed_bridgTh.Tag = 'parmBridgingTh';
lb_bridgTh = uicontrol('parent',ParametersL);
lb_bridgTh.Style = 'text';
lb_bridgTh.Units = 'Normalized';
lb_bridgTh.Position = [0.30, 0.29, 0.08, 0.05];
lb_bridgTh.String = 'Bridging threshold';

ed_pinchTh = uicontrol('parent',ParametersL);
ed_pinchTh.Style = 'Edit';
ed_pinchTh.Units = 'Normalized';
ed_pinchTh.Position = [0.40, 0.24, 0.06, 0.05];
ed_pinchTh.String = '5';
ed_pinchTh.Tag = 'parmPinchingTh';
lb_pinchTh = uicontrol('parent',ParametersL);
lb_pinchTh.Style = 'text';
lb_pinchTh.Units = 'Normalized';
lb_pinchTh.Position = [0.30, 0.23, 0.08, 0.05];
lb_pinchTh.String = 'Pinching threshold';

bg_polarity = uibuttongroup('parent',ParametersL);
bg_polarity.Units = 'Normalized';
bg_polarity.Position = [0.4,0.1,0.1,0.13];
bg_polarity.Title = 'Lines tone';

Pol1 = uicontrol('parent',bg_polarity);
Pol1.Style = 'radiobutton';
Pol1.Units = 'Normalized';
Pol1.Position = [0.1, 0.12, 0.8, 0.33];
Pol1.String = 'Negative';
Pol1.Tag = 'Pol1';

Pol2 = uicontrol('parent',bg_polarity);
Pol2.Style = 'radiobutton';
Pol2.Units = 'Normalized';
Pol2.Position = [0.1, 0.59, 0.8, 0.33];
Pol2.String = 'Positive';
Pol2.Tag = 'Pol2';
Pol2.Value = true;



pb_SaveParametes = uicontrol('parent',ParametersL);
pb_SaveParametes.Style = 'PushButton';
pb_SaveParametes.Units = 'Normalized';
pb_SaveParametes.Position = [0.8,0.2,0.1,0.05];
pb_SaveParametes.String = 'Save Parameters';
pb_SaveParametes.Callback = @SaveParms;
pb_SaveParametes.Tag = 'SaveParms';

pb_LoadParametes = uicontrol('parent',ParametersL);
pb_LoadParametes.Style = 'PushButton';
pb_LoadParametes.Units = 'Normalized';
pb_LoadParametes.Position = [0.7,0.2,0.1,0.05];
pb_LoadParametes.String = 'Load Parameters';
pb_LoadParametes.Callback = @LoadParms;
pb_LoadParametes.Tag = 'LoadParms';

ed_X1 = uicontrol('parent',ParametersL);
ed_X1.Style = 'Edit';
ed_X1.Units = 'Normalized';
ed_X1.Position = [0.88, 0.1, 0.03, 0.04];
ed_X1.String = '0.5';
ed_X1.Tag = 'X1';
ed_X2 = uicontrol('parent',ParametersL);
ed_X2.Style = 'Edit';
ed_X2.Units = 'Normalized';
ed_X2.Position = [0.83, 0.1, 0.03, 0.04];
ed_X2.String = '0.5';
ed_X2.Tag = 'X2';
ed_Y1 = uicontrol('parent',ParametersL);
ed_Y1.Style = 'Edit';
ed_Y1.Units = 'Normalized';
ed_Y1.Position = [0.88, 0.05, 0.03, 0.04];
ed_Y1.String = '0.5';
ed_Y1.Tag = 'Y1';
ed_Y2 = uicontrol('parent',ParametersL);
ed_Y2.Style = 'Edit';
ed_Y2.Units = 'Normalized';
ed_Y2.Position = [0.83, 0.05, 0.03, 0.04];
ed_Y2.String = '0.5';
ed_Y2.Tag = 'Y2';