function selectImageFolder(~,~)
h = guihandles;
ax = get(h.LinesTab,'userdata');
axp = get(h.ParametersTab,'userdata');

if ispc
    sl = '\';
else
    sl = '/';
end

if ~exist('parameters','dir')
    mkdir('parameters')
    mkdir(['parameters' sl 'AppData'])
else
    if ~exist(['parameters' sl 'AppData'],'dir')
        mkdir(['parameters' sl 'AppData'])
    end
end

if exist(['parameters' sl 'AppData' sl 'appData.mat'],'file')
    load(['parameters' sl 'AppData' sl 'appData.mat'],'folder')
    if ischar(folder)
        folder  = uigetdir(folder);
        
        save(['parameters' sl 'AppData' sl 'appData.mat'],'folder')
    else
        folder = uigetdir;
        save(['parameters' sl 'AppData' sl 'appData.mat'],'folder')
    end
else
    folder = uigetdir;
    save(['parameters' sl 'AppData' sl 'appData.mat'],'folder')
end

%%% Windows deployment
% if ~exist([ctfroot sl 'parameters'],'dir')
%     mkdir([ctfroot sl 'parameters'])
%     mkdir([ctfroot sl 'parameters' sl 'AppData'])
% else
%     if ~exist([ctfroot sl 'parameters' sl 'AppData'],'dir')
%         mkdir([ctfroot sl 'parameters' sl 'AppData'])
%     end
% end
% 
% if exist([ctfroot sl 'parameters' sl 'AppData' sl 'appData.mat'],'file')
%     load([ctfroot sl 'parameters' sl 'AppData' sl 'appData.mat'],'folder')
%     if ischar(folder)
%         folder  = uigetdir(folder);
%         
%         save([ctfroot sl 'parameters' sl 'AppData' sl 'appData.mat'],'folder')
%     else
%         folder = uigetdir;
%         save([ctfroot sl 'parameters' sl 'AppData' sl 'appData.mat'],'folder')
%     end
% else
%     folder = uigetdir;
%     save([ctfroot sl 'parameters' sl 'AppData' sl 'appData.mat'],'folder')
% end



if isequal(folder,0)
    %Operation cancelled
else
    folder = [folder sl];
    h.pb_folder.TooltipString = folder;
    
    d = dir([folder '*']);
    %doseField = cell(length(d),1);
    %waferId = cell(length(d),1);
    %ebeamDose = cell(length(d),1);
    %pitchFactor = cell(length(d),1);
    %targetPitch = cell(length(d),1);
    
    id = zeros(length(d),1);
    for n = 1:length(d)
        N = d(n).name;
        if contains(N,'.tif') || contains(N,'.jpg')
            id(n) = 1;
        end
    end
    rawImages = cell(sum(id),1);
    selectName = cell(sum(id),1);
    fileName = cell(sum(id),1);
    folderN = cell(sum(id),1);
    
    for n = 1:length(d)
        N = d(n).name;
        if id(n) == 1
            m = sum(id(1:n));
            h.lb_status.String = ['Loading ' N];
            drawnow
            rawImages{m} = imread([folder N]);
            fileName{m} = N;
            folderN{m} = folder;
            
            %    id_dash = strfind(N,'-');
            %    d_dash = strfind(N,'-d');
            %    p_dash = strfind(N,'-p');
            %    hp_dash = strfind(N,'-hp');
            %    e_dash = strfind(N,'-e');
            %
            %     if length(id_dash)>3
            %         if ~isempty(p_dash) && isempty(hp_dash)
            %             pitchFactor{n} = 1;
            %             targetPitch{n} = str2double(N(p_dash(1)+2:id_dash(3)-1));
            %         elseif isempty(p_dash) && ~isempty(hp_dash)
            %             pitchFactor{n} = 0.5;
            %             targetPitch{n} = str2double(N(hp_dash(1)+3:id_dash(3)-1));
            %         else
            %             disp(['Target pitch undetected for file: ' N]);
            %             pitchFactor{n} = nan;
            %             targetPitch{n} = nan;
            %         end
            %
            %         doseField{n} = str2double(N(d_dash(1)+2:id_dash(2)-1));
            %         ebeamDose{n} = str2double(N(e_dash(1)+2:id_dash(4)-1));
            %         waferId{n} = N(1:id_dash(1)-1);
            %     end
            %
            %     if contains(N,'ov')
            %         selectName{n} = false;
            %     else
            %         if (n<6) && (n>2)
            %             selectName{n} = true;
            %         else
            %             selectName{n} = false;
            %         end
            %         selectName{n} = true;
            %     end
            selectName{m} = true;
        end
        
    end
    h.lb_status.String = 'Idle';
    %T = unique(cell2mat(targetPitch));
    %Pitches = cell(length(T)+1,1);
    %Pitches(1)={'All pitches'};
    % for n = 1:length(T)
    %     Pitches(n+1) = {num2str(T(n))};
    % end
    %
    % h.dd_selectPitch.String = Pitches;
    
    dataTable = cell(sum(id),7);
    dataTable(:,1) = selectName;
    dataTable(:,2) = fileName;
    
    h.tab_images.Data = dataTable;
    
    AllDataTables = h.tab_images.UserData;
    if isempty(AllDataTables)
        AllDataTables=struct();
    end
    %AllDataTables.(waferId{1}) = dataTable;
    h.tab_images.UserData = AllDataTables;
    
    dataStructure = h.pb_export.UserData;
    
    dataStructure.('fileName') = fileName;
    dataStructure.('folder') = folderN;
    dataStructure.('Select') = selectName;
    dataStructure.('rawImages') = rawImages;
    dataStructure.('rawImagesAdjusted') = cell(size(rawImages));
    dataStructure.('ImagesRC') = cell(size(rawImages));
    dataStructure.('CentersB') = cell(size(rawImages));
    dataStructure.('CentersP') = cell(size(rawImages));
    %dataStructure.(waferId{1}).('waferId') = waferId;
    %dataStructure.(waferId{1}).('ebeamDose') = ebeamDose;
    %dataStructure.(waferId{1}).('doseField') = doseField;
    %dataStructure.(waferId{1}).('targetPitch') = targetPitch;
    %dataStructure.(waferId{1}).('pitchFactor') = pitchFactor;
    
    h.pb_export.UserData = dataStructure;
    
    
    
    % L = h.li_savedWafers.String;
    %
    % if isempty(L)
    %     L{1} = waferId{1};
    %     h.li_savedWafers.String = L;
    %     h.li_savedWafers.Value = 1;
    % else
    %     exflag = 0;
    %     for n=1:length(L)
    %         if strcmp(L{n},waferId{1})
    %             %h.li_savedWafers.Value = n;
    %             exflag = n;
    %         end
    %     end
    %     if exflag == 0
    %         L{length(L)+1} = waferId{1};
    %         h.li_savedWafers.String = L;
    %         h.li_savedWafers.Value = length(L);
    %     else
    %         h.li_savedWafers.Value = n;
    %     end
    % end
    % %
    % %
    %
    % h.dd_wafer.String = h.li_savedWafers.String;
    % h.dd_wafer.Value = h.li_savedWafers.Value;
    %
    % PVL = length(dataStructure.(L{h.dd_wafer.Value}).targetPitch);
    % PitchV = zeros(PVL,1);
    % for n=1:PVL
    %     PitchV(n) = dataStructure.(L{h.dd_wafer.Value}).targetPitch{n};
    % end
    % PitchV = unique(PitchV);
    % PVL = length(PitchV);
    % PitchVc = cell(PVL,1);
    % for n=1:PVL
    %     PitchVc{n} = PitchV(n);
    % end
    % h.dd_pitch.String = PitchVc;
    
    
    vs = zeros(size(selectName));
    for n = 1:size(selectName,1)
        vs(n) = selectName{n};
    end
    id = find(vs,1);
    h.pb_measure.UserData = id;
    imagesc(ax(1),rawImages{id});axis(ax(1),'image');colormap(gray)
    title(ax(1),dataStructure.fileName{id},'interpreter','none')
    imagesc(axp,rawImages{id});axis(axp,'image');colormap(gray)
    title(axp,dataStructure.fileName{id},'interpreter','none')
    h.lb_status.UserData = 1;
end
end